# VecCreateMPIWithArray

Creates a parallel, array-style vector, where the user provides the array space to store the vector values.

### Synopsis

    #include "petscvec.h"
    PetscErrorCode  VecCreateMPIWithArray(MPI_Comm comm,PetscInt n,PetscInt N,const PetscScalar array[],Vec *vv)

Collective on MPI_Comm

### Input Parameters

| comm | - the MPI communicator to use
| n | - local vector length, cannot be PETSC_DECIDE
| N | - global vector length (or PETSC_DECIDE to have calculated)
| array | - the user provided array to store the vector values

### Output Parameter

vv -the vector

### C++ variants

| VecCreateMPIWithArray(PetscInt n,PetscInt N,PetscScalar s[],Vec *x) |  | -> |  | VecCreateMPIWithArray(PETSC_COMM_WORLD,n,N,s,x)

### Notes

Use VecDuplicate() or VecDuplicateVecs() to form additional vectors of the same type as an existing vector.

If the user-provided array is PETSC_NULL, then VecPlaceArray() can be used at a later stage to SET the array for storing the vector values.

PETSc does NOT free the array when the vector is destroyed via VecDestroy(). The user should not free the array until the vector is destroyed.

### See Also

VecCreateSeqWithArray(), VecCreate(), VecDuplicate(), VecDuplicateVecs(), VecCreateGhost(),
VecCreateMPI(), VecCreateGhostWithArray(), VecPlaceArray()

Level:intermediate
Location: src/vec/vec/impls/mpi/pbvec.c
Index of all Vec routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/dm/ao/examples/tutorials/ex2.c.html